#pragma once

#include "AppDefine.h"

/**
 *	@brief CInstanceChecker
 */
class CInstanceChecker
{
public:
	CInstanceChecker(LPCTSTR szMutexName)
	{
		m_bExist = FALSE;
		m_hMutex = NULL;
		m_hMutex = ::CreateMutex(NULL, TRUE, szMutexName );
		if (m_hMutex == NULL || ERROR_ALREADY_EXISTS == ::GetLastError())
		{
			m_bExist = TRUE;
		}
	}

	~CInstanceChecker()
	{
		if (m_hMutex != NULL)
		{
			::CloseHandle(m_hMutex);
		}

	}

	BOOL IsExist()
	{
		return m_bExist;
	}
	
private:
	HANDLE	m_hMutex;
	BOOL	m_bExist;
};


#define DECLARE_RUN_MUTEX CInstanceChecker ic(RUN_MUTEX_NAME);
#define DECLARE_INSTALL_MUTEX CInstanceChecker ic(NSIS_MUTEX_NAME_SETUP);
#define DECLARE_UPDATE_MUTEX CInstanceChecker ic(UPDATE_MUTEX_NAME);
#define DECLARE_UNINSTALL_MUTEX CInstanceChecker ic(UNINSTALL_MUTEX_NAME);

#define IS_EXIST_MUTEX (ic.IsExist())
